// Licensed to the .NET Foundation under one or more agreements.
// The .NET Foundation licenses this file to you under the MIT license.

namespace System.Drawing.Imaging
{
    /// <summary>
    /// Specifies two modes for color component values.
    /// </summary>
    public enum ColorMode
    {
        /// <summary>
        /// Specifies that integer values supplied are 32-bit values.
        /// </summary>
        Argb32Mode = 0,
        /// <summary>
        /// Specifies that integer values supplied are 64-bit values.
        /// </summary>
        Argb64Mode = 1
    }
}
